searchData={"items":[{"type":"module","title":"Bildad","doc":"This module is the entry point for the Bildad Jobs Framework.\n\nPlease see the README for more information.","ref":"Bildad.html"},{"type":"module","title":"Bildad.Job.JobConfig","doc":"Configuration for the Bildad job scheduling framework.","ref":"Bildad.Job.JobConfig.html"},{"type":"function","title":"Bildad.Job.JobConfig.new/2","doc":"Creates a new JobConfig struct for the provided database repository.\n\nPrefer this function over directly creating the struct as the struct internals may change over time.","ref":"Bildad.Job.JobConfig.html#new/2"},{"type":"module","title":"Bildad.Job.JobEngine","doc":"This module contains the logic for enqueuing, running, killing and expiring jobs in the Bildad job scheduling framework.","ref":"Bildad.Job.JobEngine.html"},{"type":"function","title":"Bildad.Job.JobEngine.complete_a_job/2","doc":"Used to mark a job as completed successfully.","ref":"Bildad.Job.JobEngine.html#complete_a_job/2"},{"type":"function","title":"Bildad.Job.JobEngine.enqueue_and_run_job/4","doc":"Enqueues a job and runs it immediately. \n\nThis should be used sparingly as it bypasses the priority of other jobs in the queue.","ref":"Bildad.Job.JobEngine.html#enqueue_and_run_job/4"},{"type":"function","title":"Bildad.Job.JobEngine.enqueue_job/4","doc":"Adds a job to the queue. The order it will be run in will be based on priority and resource availability.\n\nEach message contains a `job_context` which is a map of data that will be passed to the job module when it is run.\nThis job context must conform to the schema defined in the job template.","ref":"Bildad.Job.JobEngine.html#enqueue_job/4"},{"type":"function","title":"Bildad.Job.JobEngine.enqueue_job_and_trigger_engine/4","doc":"Enqueues a job and triggers the job engine to run immediately.\n\nIf there are other jobs ahead of this one in the queue that are higher priority, they will be run first.\n\nThis is the preferred over `enqueue_and_run_job` as it respects the priority of other jobs in the queue.\n\nTODO: This should make the same API call that the cron job makes and it should check to see if the job engine is already running before starting it.","ref":"Bildad.Job.JobEngine.html#enqueue_job_and_trigger_engine/4"},{"type":"function","title":"Bildad.Job.JobEngine.expire_a_job/2","doc":"Used when a job is not running on any node and the expiration time has been reached.","ref":"Bildad.Job.JobEngine.html#expire_a_job/2"},{"type":"function","title":"Bildad.Job.JobEngine.fail_a_job/3","doc":"Jobs that come to completion and are not successful are marked as failed.","ref":"Bildad.Job.JobEngine.html#fail_a_job/3"},{"type":"function","title":"Bildad.Job.JobEngine.find_elixir_process/1","doc":"Locates the Elixir process by the job identifier.\nIf the process is not running or is running on another node then nil is returned.","ref":"Bildad.Job.JobEngine.html#find_elixir_process/1"},{"type":"function","title":"Bildad.Job.JobEngine.get_counts/1","doc":"Utility function go get the number of successful jobs and the number of jobs that failed.","ref":"Bildad.Job.JobEngine.html#get_counts/1"},{"type":"function","title":"Bildad.Job.JobEngine.get_retry_count/2","doc":"The queue entry points to the current run which has its retry count.\nThis function increments that number by one OR it returns 0 if there is not a currently running job (which is\nthe initial state of an enqueued job).","ref":"Bildad.Job.JobEngine.html#get_retry_count/2"},{"type":"function","title":"Bildad.Job.JobEngine.kill_a_job/2","doc":"If the Elixir process is running on this node then it kills the process and updates the database record.\n\nIf not, nothing happens on this node. The other nodes should being runnig this function as well and the\nprocess will be stopped on one of them.\nIf the process is not running on any node the job will eventually expire when the expiration time is reached.\nThe `expire_a_job` function should be called to handle that case. (This is done by the job engine.)","ref":"Bildad.Job.JobEngine.html#kill_a_job/2"},{"type":"function","title":"Bildad.Job.JobEngine.launch_job_process/2","doc":"Launches the Elixir process for the job passing it the job context.\nIt registers the process with the job identifier so that it can be found later.","ref":"Bildad.Job.JobEngine.html#launch_job_process/2"},{"type":"function","title":"Bildad.Job.JobEngine.remove_job_from_queue/2","doc":"Removes a job from the queue. This is typically called when a job is completed or when a user wishes to no longer run the job.","ref":"Bildad.Job.JobEngine.html#remove_job_from_queue/2"},{"type":"function","title":"Bildad.Job.JobEngine.run_a_job/2","doc":"This function is called by the job scheduler to run a job.","ref":"Bildad.Job.JobEngine.html#run_a_job/2"},{"type":"function","title":"Bildad.Job.JobEngine.run_job_engine/1","doc":"This function is called by the job scheduler to run the job engine.\n\nThis should be called by a single cron job in your environment so that the engine is run on one node at a time.","ref":"Bildad.Job.JobEngine.html#run_job_engine/1"},{"type":"function","title":"Bildad.Job.JobEngine.stop_job_in_queue/2","doc":"This function is called by the job scheduler to stop a job that is currently running.\nThis ONLY updates the record in the database, it does NOT stop the elixir process.\nTo stop the Elixir process if it is still running then `kill_a_job` should be called.","ref":"Bildad.Job.JobEngine.html#stop_job_in_queue/2"},{"type":"function","title":"Bildad.Job.JobEngine.try_to_kill_process/1","doc":"Tries to kill the process by sending an exit signal.","ref":"Bildad.Job.JobEngine.html#try_to_kill_process/1"},{"type":"function","title":"Bildad.Job.JobEngine.validate_job_context/2","doc":"Each job has a schema that defines the shape of the data that will be passed to the job module when it is run.","ref":"Bildad.Job.JobEngine.html#validate_job_context/2"},{"type":"module","title":"Bildad.Job.JobKiller","doc":"The JobKiller module is responsible for killing jobs that have run too long.","ref":"Bildad.Job.JobKiller.html"},{"type":"function","title":"Bildad.Job.JobKiller.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"Bildad.Job.JobKiller.html#child_spec/1"},{"type":"function","title":"Bildad.Job.JobKiller.run/2","doc":"Checks for jobs that need to be killed ON THIS NODE and tries to kill them.","ref":"Bildad.Job.JobKiller.html#run/2"},{"type":"function","title":"Bildad.Job.JobKiller.start_link/1","doc":"Starts the JobKiller task with the provided options. This task should be run on each node.\n\nThe repo is required and is the database repository to use for job management.\nThe check time is the number of seconds between checks for jobs to kill. It is OPTIONAL and defaults to 60 seconds.","ref":"Bildad.Job.JobKiller.html#start_link/1"},{"type":"module","title":"Bildad.Job.JobQueueEntry","doc":"","ref":"Bildad.Job.JobQueueEntry.html"},{"type":"function","title":"Bildad.Job.JobQueueEntry.changeset/2","doc":"","ref":"Bildad.Job.JobQueueEntry.html#changeset/2"},{"type":"module","title":"Bildad.Job.JobRun","doc":"","ref":"Bildad.Job.JobRun.html"},{"type":"function","title":"Bildad.Job.JobRun.changeset/2","doc":"","ref":"Bildad.Job.JobRun.html#changeset/2"},{"type":"module","title":"Bildad.Job.JobTemplate","doc":"","ref":"Bildad.Job.JobTemplate.html"},{"type":"function","title":"Bildad.Job.JobTemplate.changeset/2","doc":"","ref":"Bildad.Job.JobTemplate.html#changeset/2"},{"type":"module","title":"Bildad.Job.Jobs","doc":"The Jobs module is responsible for managing job templates, job queue entries, and job runs.","ref":"Bildad.Job.Jobs.html"},{"type":"function","title":"Bildad.Job.Jobs.create_job_template/2","doc":"Creates a new job template with the provided attributes.\n\nNote that the module_name should be a string version of the Elixir module name that will be used to run the job.\n\nNote that the job_context_schema should be a map that represents the schema of the context that will be passed to the job module. \nIt will be used to validate the context before running the job.","ref":"Bildad.Job.Jobs.html#create_job_template/2"},{"type":"function","title":"Bildad.Job.Jobs.delete_job_template/2","doc":"Deletes the provided job template.","ref":"Bildad.Job.Jobs.html#delete_job_template/2"},{"type":"function","title":"Bildad.Job.Jobs.list_active_job_templates/1","doc":"Lists all the active job templates without pagination.","ref":"Bildad.Job.Jobs.html#list_active_job_templates/1"},{"type":"function","title":"Bildad.Job.Jobs.list_all_job_runs/3","doc":"Lists all the job runs with pagination.","ref":"Bildad.Job.Jobs.html#list_all_job_runs/3"},{"type":"function","title":"Bildad.Job.Jobs.list_all_job_templates/1","doc":"Lists all the active job templates without pagination.","ref":"Bildad.Job.Jobs.html#list_all_job_templates/1"},{"type":"function","title":"Bildad.Job.Jobs.list_all_jobs_in_the_queue/1","doc":"Lists all the jobs in the queue without pagination.","ref":"Bildad.Job.Jobs.html#list_all_jobs_in_the_queue/1"},{"type":"function","title":"Bildad.Job.Jobs.list_all_jobs_in_the_queue/3","doc":"Lists all the jobs in the queue with pagination.","ref":"Bildad.Job.Jobs.html#list_all_jobs_in_the_queue/3"},{"type":"function","title":"Bildad.Job.Jobs.list_expired_jobs/1","doc":"Lists all the jobs that were running, have not been killed and have expired without pagination.","ref":"Bildad.Job.Jobs.html#list_expired_jobs/1"},{"type":"function","title":"Bildad.Job.Jobs.list_expired_jobs/3","doc":"Lists all the jobs that were running, have not been killed and have expired with pagination (with the default page size if nil provided as the page size).","ref":"Bildad.Job.Jobs.html#list_expired_jobs/3"},{"type":"function","title":"Bildad.Job.Jobs.list_inactive_job_templates/1","doc":"Lists all the inactive job templates without pagination.","ref":"Bildad.Job.Jobs.html#list_inactive_job_templates/1"},{"type":"function","title":"Bildad.Job.Jobs.list_job_runs_for_result/2","doc":"Lists all the jobs that have finished with the provided result without pagination.","ref":"Bildad.Job.Jobs.html#list_job_runs_for_result/2"},{"type":"function","title":"Bildad.Job.Jobs.list_job_runs_for_result/4","doc":"Lists all the jobs that have finished with the provided result with pagination (with the default page size if nil provided as the page size).","ref":"Bildad.Job.Jobs.html#list_job_runs_for_result/4"},{"type":"function","title":"Bildad.Job.Jobs.list_job_runs_to_kill/1","doc":"Lists all the jobs that are running and have timed out without pagination.","ref":"Bildad.Job.Jobs.html#list_job_runs_to_kill/1"},{"type":"function","title":"Bildad.Job.Jobs.list_job_runs_to_kill/3","doc":"Lists all the jobs that are running and have timed out with pagination (with the default page size if nil provided as the page size).","ref":"Bildad.Job.Jobs.html#list_job_runs_to_kill/3"},{"type":"function","title":"Bildad.Job.Jobs.list_job_templates/1","doc":"Lists all the active job templates without pagination.","ref":"Bildad.Job.Jobs.html#list_job_templates/1"},{"type":"function","title":"Bildad.Job.Jobs.list_jobs_for_status_in_the_queue/2","doc":"Lists all the jobs for the given status in the queue without pagination.","ref":"Bildad.Job.Jobs.html#list_jobs_for_status_in_the_queue/2"},{"type":"function","title":"Bildad.Job.Jobs.list_jobs_for_status_in_the_queue/4","doc":"Lists all the jobs for the given status in the queue with pagination (with the default page size if nil provided for the page size).","ref":"Bildad.Job.Jobs.html#list_jobs_for_status_in_the_queue/4"},{"type":"function","title":"Bildad.Job.Jobs.list_jobs_to_run_in_the_queue/1","doc":"Lists all the jobs that are available to run in the queue without pagination.","ref":"Bildad.Job.Jobs.html#list_jobs_to_run_in_the_queue/1"},{"type":"function","title":"Bildad.Job.Jobs.list_jobs_to_run_in_the_queue/3","doc":"Lists all the jobs that are available to run in the queue with pagination.","ref":"Bildad.Job.Jobs.html#list_jobs_to_run_in_the_queue/3"},{"type":"function","title":"Bildad.Job.Jobs.list_running_jobs_in_the_queue/1","doc":"Lists all the jobs that are running in the queue without pagination.","ref":"Bildad.Job.Jobs.html#list_running_jobs_in_the_queue/1"},{"type":"function","title":"Bildad.Job.Jobs.list_running_jobs_in_the_queue/3","doc":"Lists all the jobs that are running in the queue with pagination.","ref":"Bildad.Job.Jobs.html#list_running_jobs_in_the_queue/3"},{"type":"function","title":"Bildad.Job.Jobs.update_job_template/3","doc":"Updates the provided job template with the provided attributes.","ref":"Bildad.Job.Jobs.html#update_job_template/3"},{"type":"task","title":"mix bildad.install","doc":"","ref":"Mix.Tasks.Bildad.Install.html"},{"type":"function","title":"Mix.Tasks.Bildad.Install.do_install/1","doc":"","ref":"Mix.Tasks.Bildad.Install.html#do_install/1"},{"type":"function","title":"Mix.Tasks.Bildad.Install.get_template_file_path/1","doc":"","ref":"Mix.Tasks.Bildad.Install.html#get_template_file_path/1"},{"type":"function","title":"Mix.Tasks.Bildad.Install.run/1","doc":"","ref":"Mix.Tasks.Bildad.Install.html#run/1"},{"type":"function","title":"Mix.Tasks.Bildad.Install.usage/0","doc":"","ref":"Mix.Tasks.Bildad.Install.html#usage/0"},{"type":"function","title":"Mix.Tasks.Bildad.Install.zero_pad/1","doc":"","ref":"Mix.Tasks.Bildad.Install.html#zero_pad/1"},{"type":"extras","title":"Bildad","doc":"# Bildad\n\nFramework for running async jobs in an Elixir LiveView application.\n\nBildad is designed to run in a cluster of nodes that are NOT connected but share the same database.\n\nA JobKiller application runs on each node looking for jobs to kill on that node.\n\nA controller listens for requests to run the engine so that jobs will be started on ONE node.\n\nJobs that time out will eventually be killed. Jobs that die but are not killed will be expired.\n\nA message with a configurable number of retires is put in the job queue to run a job. When the job is completed, killed or expired it is removed from the queue table. Entries in the queue can have the following status:\n\n* AVAILABLE\n* RUNNING\n\nAfter the maximum number of retires messages are removed from the jobs queue.\n\nEach run of a job in the message queue is stored in the `job runs` table. It contains the retry number and information about how long the job took along with the following:\n\n* status (RUNNING, DONE)\n* result (SUCCEEDED, FAILED)\n* reason (text description of why a run failed)","ref":"readme.html"},{"type":"extras","title":"Installation - Bildad","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `bildad` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:bildad, \"~> 0.1.0\"}\n  ]\nend\n```\n\nRun the mix task to install the necessary migration and controller.\n\n```bash\nmix bildad.install\n```\n\nFollow the instructions for modifying the `router.ex` file.\n\n```elixir\npost \"/jobs/engine/run\", Jobs.JobsController, :run_job_engine\n```\n\nFollow the instructions for modifying the `application.ex` file.\n\n```elixir\n{Bildad.Job.JobKiller, repo: MyApp.Repo, check_time_in_seconds: 20},\n```\n\n> [!NOTE]\n> You must call the run_job_engine periodically (via cron for example).\n\nYou must also create Job Templates for the jobs that you plan on running. They must \ncontain the string version of the Elixir module to run and a JSON schema definition\nso that the job context can be validated before a job is run.","ref":"readme.html#installation"},{"type":"extras","title":"Architecture - Bildad","doc":"* a database that works with Ecto\n* a phoenix controller that listens for requests and runs the job engine\n* a cron job to periodically run the jobs engine\n  * the request will only hit one server and the engine will run on that node\n* a job engine that runs on one node at a time\n  * this expires old jobs that have all timed out and cannot be killed on any node\n  * this runs new jobs in the queue that are available to run\n* a job killer task that is run on each node\n* custom jobs that have a `run_job` function that takes the job context\n* job templates that know the module name and have the schema for the job context\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#architecture"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}